property whichevent, whichLabel, playmode

on triggerGotoMarker me
  trigger(me)
end

on mouseUp me
  if whichevent = #mouseUp then
    trigger(me)
  end if
end

on mouseDown me
  if whichevent = #mouseDown then
    trigger(me)
  end if
end

on prepareFrame me
  if whichevent = #prepareFrame then
    trigger(me)
  end if
end

on enterFrame me
  if whichevent = #enterFrame then
    trigger(me)
  end if
end

on exitFrame me
  if whichevent = #exitFrame then
    trigger(me)
  end if
end

on trigger me
  if the playmode of me = "Go to" then
    case whichLabel of
      #previous:
        go(marker(-1))
      #loop:
        go(marker(0))
      #next:
        go(marker(1))
      otherwise:
        go(whichLabel)
    end case
  else
    case whichLabel of
      #previous:
        play frame marker(-1)
      #loop:
        play frame marker(0)
      #next:
        play frame marker(1)
      otherwise:
        play frame whichLabel
    end case
  end if
end

on getPropertyDescriptionList
  set description to [:]
  addProp(description, #whichLabel, [#comment: "Destination Marker:", #format: #marker, #default: "#Loop"])
  addProp(description, #whichevent, [#comment: "Triggering Event:", #format: #symbol, #range: [#mouseUp, #mouseDown, #prepareFrame, #enterFrame, #exitFrame], #default: #mouseUp])
  addProp(description, #playmode, [#comment: "Play Mode:", #format: #symbol, #range: ["Go to", "Play and Return"], #default: "Go to"])
  return description
end

on getBehaviorDescription
  return "Go to a designated Marker when the specified Event occurs." && RETURN & "PARAMETERS:" && RETURN & "• Destination Marker - choose from a list of marker names in the current movie or navigate relative to the current frame using the relative marker names Previous, Loop (Current), or Next." && RETURN & "• Triggering Event - the event that should initiate navigation." & RETURN & "• Play Mode - specifies control flow when requested movie is completed.  Play and Return will continue with the previous movie at the point where it left off.  Go To will never return."
end
