property PlayMember, PlayMemberNum, StopMember, StopMemberNum, PlayRate, VideoSprite, savedPlayRate, PlayMemberName, StopMemberName

on Toggle me
  if PlayRate <> 0 then
    set savedPlayRate to PlayRate
    set PlayRate to 0
    setValue(me, 0)
  else
    set PlayRate to savedPlayRate
    setValue(me, PlayRate)
  end if
  set the movieRate of sprite VideoSprite to the PlayRate of me
end

on setValue me, v_me
  if v_me = 0 then
    set the member of sprite the spriteNum of me to the PlayMember of me
  else
    set the member of sprite the spriteNum of me to the StopMember of me
  end if
end

on mouseUp me
  Toggle(me)
end

on beginSprite me
  set s to the spriteNum of me
  set PlayMemberNum to member the PlayMemberName of me
  set StopMemberNum to member the StopMemberName of me
  set the StopMember of me to member the StopMemberNum of me
  set the PlayMember of me to member the PlayMemberNum of me
  set the PlayRate of me to the movieRate of sprite VideoSprite
  if the PlayRate of me = 0 then
    set savePlayRate to 1
  else
    set savePlayRate to 0
  end if
  if PlayRate <> 0 then
    setValue(me, PlayRate)
    set savedPlayRate to PlayRate
  else
    setValue(me, 0)
    set savedPlayRate to 1
  end if
end

on getPropertyDescriptionList
  set description to [:]
  addProp(description, #VideoSprite, [#default: the currentSpriteNum + 4, #format: #integer, #comment: "Video Sprite:"])
  addProp(description, #PlayMemberName, [#comment: "Member Name of Play Image:", #format: #bitmap, #default: "QTplay"])
  addProp(description, #StopMemberName, [#comment: "Member Name of Stop Image:", #format: #bitmap, #default: "QTStop"])
  return description
end

on getBehaviorDescription
  return "Toggle to control digital video sprite.  Drag to picture of stop image.  Will check what the video is doing and display the appropriate button." & RETURN & "PARAMETERS:" & RETURN & "• Video Sprite - sprite number of video." & RETURN & "• Play Image - number of castmember providing image displayed when QT is stopped."
end

on getAssocMembers
  set myPropList to [StopMemberName, "Widget Area"]
  return myPropList
end
