property switchdelay, nexttime, palmin, palmax, scope, mode

on getPropertyDescriptionList
  set description to [:]
  addProp(description, #switchdelay, [#default: 30, #format: #float, #comment: "Interval (ticks)"])
  addProp(description, #palmin, [#default: 0, #format: #float, #comment: "lowest palette value"])
  addProp(description, #palmax, [#default: 255, #format: #float, #comment: "highest palette value"])
  addProp(description, #scope, [#default: #forecolor, #format: #symbol, #comment: "Scope", #range: [#forecolor, #backcolor, #both]])
  addProp(description, #mode, [#default: #random, #format: #symbol, #comment: "Mode", #range: [#random, #cycle_up, #cycle_down]])
  return description
end

on getBehaviorDescription
  return "cycles through color palette"
end

on beginSprite me
  puppetSprite(the spriteNum of me, 1)
  set the nexttime of me to the ticks + the switchdelay of me
end

on endSprite me
  puppetSprite(the spriteNum of me, 0)
end

on prepareFrame me
  if the ticks >= the nexttime of me then
    set mySprite to the spriteNum of me
    case mode of
      #random:
        set range to the palmax of me - the palmin of me + 1
        set new_color to random(range) + the palmin of me - 1
        case the scope of me of
          #forecolor:
            set the foreColor of sprite mySprite to new_color
          #backcolor:
            set the backColor of sprite mySprite to new_color
          #both:
            set the backColor of sprite mySprite to new_color
            set new_color to random(range) + the palmin of me - 1
            set the foreColor of sprite mySprite to new_color
        end case
      #cycle_up:
        set increment to 1
        bumpColors(me, increment)
      #cycle_down:
        set increment to -1
        bumpColors(me, increment)
    end case
    set the nexttime of me to the ticks + the switchdelay of me
  end if
end

on bumpColors me, increment
  case the scope of me of
    #forecolor:
      changeColor(me, #fore, increment)
    #backcolor:
      changeColor(me, #back, increment)
    #both:
      changeColor(me, #fore, increment)
      changeColor(me, #back, increment)
  end case
end

on changeColor me, whichcolor, amount
  set mySprite to the spriteNum of me
  if whichcolor = #fore then
    set newcolor to the foreColor of sprite mySprite
  else
    set newcolor to the backColor of sprite mySprite
  end if
  set newcolor to newcolor + amount
  if newcolor < palmin then
    set newcolor to palmax
  end if
  if newcolor > palmax then
    set newcolor to palmin
  end if
  if whichcolor = #fore then
    set the foreColor of sprite mySprite to newcolor
  else
    set the backColor of sprite mySprite to newcolor
  end if
end
